;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program - drawing bezier surfaces
;;           without OpenGL using
;; author  - Maciej Guba aka macgub
;; email   - macgub3@wp.pl
;; web     - macgub.hekko.pl
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
format PE GUI 4.0
entry start

include '/include/win32a.inc'

XRES equ 1280 ;1600 ;1200 ;800      ;choose screen size
YRES equ 1024 ; 900 ; 675 ;450
MAX_COUNTER equ 80  ; shuld by divisable by 4 or by 8 in AVX cause

;SIZE_X  equ XRES
;SIZE_Y  equ YRES
;ROUND equ 8
;NON = 0
;MMX = 1
;SSE = 2
SSE2 = 3
;SSE3 = 4
AVX = 5 ; avx version not ready to run
Ext = SSE2


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    mov [bmi.biSize],sizeof.BITMAPINFOHEADER
    mov [bmi.biWidth],XRES
    mov [bmi.biHeight],-YRES
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],XRES
    mov [rect.bottom],YRES
    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0 

    invoke RegisterClass,wc

    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left] 

    invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
	   xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW

;    fninit                   ; prepare some variables
;    fild   [xres_var]
;    fst    dword[maxx]
;    fst    dword[maxx+4]
;    fst    dword[maxx+8]
;    fstp   dword[maxx+12]
;    fild   dword[yres_var]
;    fst    dword[maxy]
;    fst    dword[maxy+4]
;    fst    dword[maxy+8]
;    fstp   dword[maxy+12]
			      ; init_scale
    mov      eax,XRES/320
    cvtsi2ss xmm0,eax
    movss    [scale],xmm0

    mov      ax,[maxcountervar]
  if Ext = AVX
    shr      ax,3
  else
    shr      ax,2
  end if
    mov      [maxcountervarExt],ax


    invoke timeGetTime
    mov [s_time],eax	     ;initialize start time

msg_loop:
    invoke timeGetTime
    sub eax,[s_time]
    mov [e_time],eax	     ;get new end time

    stdcall g_draw
    inc  [ccounter]
    and  [ccounter],0x000000ff
    invoke StretchDIBits,[hdc],0,0,XRES,YRES,0,0,XRES,YRES,buffer,bmi,0,SRCCOPY
  ;  invoke Sleep,2
  ;  call   update_p

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg

    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:
    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish
  .wmkeydown:
    cmp [wparam],VK_UP
    jne .vescape_or_set_flag
;    stdcall g_init
    xor eax,eax
    jmp .finish
  .vescape_or_set_flag:
    cmp [wparam],VK_ESCAPE
    je	.wmdestroy
    cmp [wparam],VK_SPACE
    jne .finish
    cmp [draw_flag],1
    je	@f
    inc [draw_flag]
    jmp .finish
   @@:
    mov [draw_flag],0
    jmp .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish: 
    ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw uses ebx esi edi
local temp dw ?
local zz1 dw ?, zz2 dw ?, zz3 dw ?
local xx1 dw ?, xx2 dw ?, xx3 dw ?
local yy1 dw ?, yy2 dw ?, yy3 dw ?
    pushad
    fninit
    xor   eax,eax	   ; clear draw buffer
    mov   edi,buffer
    cld
    mov   ecx,XRES * YRES
    rep   stosd


  .rotate:
    fninit
    mov    esi,object
    mov    edi,object_rotated
    fild   [ccounter]
;    fld1
    fmul   [one_deg]
    fsincos
    fstp   [cos_beta]
    fstp   [sin_beta]

 @@:
    fld    dword[esi+4]
    fmul   [cos_beta]
    fld    dword[esi+8]
    fmul   [sin_beta]
    faddp
    fld    dword[esi+4]
    fmul   [sin_beta]
    fchs
    fld     dword[esi+8]
    fmul   [cos_beta]
    faddp
    fmul   [scale]
    fstp   dword[edi+8]
    fmul   [scale]
    fstp   dword[edi+4]
    fld    dword[esi]
    fmul   [scale]
    fstp   dword[edi]

    fld    dword[edi]
    fld    st
    fmul   [cos_beta]
    fld    dword[edi+8]
    fmul   [sin_beta]
    fchs
    faddp
    fstp   dword[edi]
    fmul   [sin_beta]
    fld    dword[edi+8]
    fmul   [cos_beta]
    faddp
    fstp   dword[edi+8]

    add    esi,12
    add    edi,12
    cmp    dword[esi],-1

    jnz    @b
    push   dword[esi]
    pop    dword[edi]

    mov   [surface_no],0

 @@:

    call  calc_surface

    add   [surface_no],1
    cmp   [surface_no],32
    jnz   @b

    popad
ret
endp
calc_surface:
pushad
  if Ext = SSE2
    fninit
    fld1
    fidiv   [maxcountervar]
    fst     [step]
    movss   xmm0,[step]
    shufps  xmm0,xmm0,0
    movaps  xmm1,xmm0
    mulps   xmm0,[const0123]
    movaps  [s1],xmm0
    mulps   xmm1,[const4]
    movaps  [step4],xmm1
    xor    eax,eax
  .loops:
    push eax
	xor    ebx,ebx
	movss  xmm0,[step]
	shufps xmm0,xmm0,0
	mulps  xmm0,[const0123]
	movaps [t1],xmm0

      .loopt:
	 ; int3
	push ebx
	call calc_abcd

	call calc_voxel
	call putpixel


	movaps	xmm0,[t1]
	addps	xmm0,[step4]
	movaps	[t1],xmm0


	pop   ebx
	inc   ebx
	cmp   bx,[maxcountervarExt]
	jnz   .loopt
    movaps  xmm0,[s1]
    addps   xmm0,[step4]
    movaps  [s1],xmm0

    pop  eax
    inc  eax
    cmp  ax,[maxcountervarExt]
    jnz  .loops

  else

    fninit
    fld1
    fidiv	 [maxcountervar]
    fst 	 [step]
    vbroadcastss ymm0,[step]
    vmulps	 ymm1,ymm0,[const8]
    vmovaps	 [step8],ymm1
    vmulps	 ymm0,ymm0,[const0123]
    vmovaps	 [s1],ymm0

;    movss   xmm0,[step]
;    shufps  xmm0,xmm0,0
;    movaps  xmm1,xmm0
;    mulps   xmm0,[const0123]
;    movaps  [s1],xmm0
;    mulps   xmm1,[const4]
;    movaps  [step4],xmm1
    xor    eax,eax
  .loops:
    push eax
	xor    ebx,ebx
	vbroadcastss  ymm2,[step]
	vmulps	       ymm2,ymm2,[const0123]
	vmovaps       [t1],ymm2

;        movss  xmm0,[step]
;        shufps xmm0,xmm0,0
;        mulps  xmm0,[const0123]
;        movaps [t1],xmm0

      .loopt:
	 ; int3
	push ebx
	call calc_abcd

	call calc_voxel
	call putpixel


 ;       movaps  xmm0,[t1]
 ;       addps   xmm0,[step4]
 ;       movaps  [t1],xmm0
	vmovaps  ymm3,[t1]
	vaddps	 ymm3,ymm3,[step8]
	vmovaps  [t1],ymm3

	pop   ebx
	inc   ebx
	cmp   bx,[maxcountervarExt]
	jnz   .loopt
    vmovaps ymm2,[s1]
    vaddps  ymm2,ymm2,[step8]
    vmovaps [s1],ymm2
;    movaps  xmm0,[s1]
;    addps   xmm0,[step4]
;    movaps  [s1],xmm0

    pop  eax
    inc  eax
    cmp  ax,[maxcountervarExt]
    jnz  .loops
  end if
popad
ret

calc_abcd:
if Ext=AVX
  vbroadcastss ymm0,[const1]
  vsubps       ymm0,ymm0,[t1]
  vmovaps      ymm1,ymm0
  vmovaps      ymm2,ymm0
  vmulps       ymm1,ymm1,ymm1
  vmulps       ymm7,ymm1,ymm0
;  vmovaps      ymm7,ymm1
  vmulps       ymm0,ymm0,ymm0
  vmulps       ymm0,ymm0,[t1]
  vmulps       ymm6,ymm0,[const3]
;  vmovaps      ymm6,ymm0
  vmulps       ymm2,ymm2,[const3]
  vmulps       ymm2,ymm2,[t1]
  vmulps       ymm5,ymm2,[t1]
;  vmovaps      ymm5,ymm2
  vmovaps      ymm3,[t1]
  vmulps       ymm4,ymm3,ymm3
  vmulps       ymm4,ymm4,ymm3

else
  movaps  xmm0,[const1]
  subps   xmm0,[t1]
  movaps  xmm1,xmm0
  movaps  xmm2,xmm0
  mulps   xmm1,xmm1
  mulps   xmm1,xmm0
  movaps  xmm7,xmm1   ;     [a1]
  mulps   xmm0,xmm0
  mulps   xmm0,[t1]
  mulps   xmm0,[const3]
  movaps  xmm6,xmm0    ;   [b1]
  mulps   xmm2,[const3]
  mulps   xmm2,[t1]
  mulps   xmm2,[t1]
  movaps  xmm5,xmm2    ;   [c1]
  movaps  xmm3,[t1]
  mulps   xmm3,xmm3
  mulps   xmm3,[t1]
  movaps  xmm4,xmm3    ;    [d1]
end if
ret

calc_voxel:
  fninit
  mov	esi,object_rotated
  xor	ebx,ebx
  mov	edi,[surface_no]
  shl	edi,6
  lea	edi,[edi*3]
  add	esi,edi

 .ddraw:
if Ext = AVX
 ; int3
  vbroadcastss	ymm0,[esi+ebx]
  vmulps	ymm0,ymm0,ymm7
  vbroadcastss	ymm1,[esi+ebx+12]
  vmulps	ymm1,ymm1,ymm6
  vaddps	ymm0,ymm0,ymm1
  vbroadcastss	ymm2,[esi+ebx+12*2]
  vmulps	ymm2,ymm2,ymm5
  vaddps	ymm0,ymm0,ymm2
  vbroadcastss	 ymm1,[esi+ebx+12*3]
  vmulps	ymm1,ymm1,ymm4
  vaddps	ymm0,ymm0,ymm1

  vbroadcastss	ymm1,[const1]
  vsubps	ymm1,ymm1,[s1]
  vmulps	ymm2,ymm1,ymm1
  vmulps	ymm2,ymm1,ymm2
  vmulps	ymm2,ymm1,ymm2
  vmulps	ymm0,ymm0,ymm2

  vbroadcastss	ymm1,[esi+ebx+12*4]
  vmulps	ymm1,ymm1,ymm7
  vbroadcastss	ymm2,[esi+ebx+12*5]
  vmulps	ymm2,ymm2,ymm6
  vaddps	ymm1,ymm1,ymm2
  vbroadcastss	ymm3,[esi+ebx+12*6]
  vmulps	ymm3,ymm3,ymm5
  vaddps	ymm1,ymm1,ymm3
  vbroadcastss	ymm2,[esi+ebx+12*7]
  vmulps	ymm2,ymm2,ymm4
  vaddps	ymm1,ymm1,ymm2
  vbroadcastss	ymm3,[const1]
  vsubps	ymm3,ymm3,[s1]
  vmulps	ymm3,ymm3,ymm3
  vmulps	ymm3,ymm3,[s1]
  vmulps	ymm3,ymm3,[const3]
  vmulps	ymm3,ymm3,ymm1
  vaddps	ymm0,ymm0,ymm3

  vbroadcastss	ymm1,[esi+ebx+12*8]
  vmulps	ymm1,ymm1,ymm7
  vbroadcastss	ymm2,[esi+ebx+12*9]
  vmulps	ymm2,ymm2,ymm6
  vaddps	ymm1,ymm1,ymm2
  vbroadcastss	ymm3,[esi+ebx+12*10]
  vmulps	ymm3,ymm3,ymm5
  vaddps	ymm1,ymm1,ymm3
  vbroadcastss	ymm2,[esi+ebx+12*11]
  vmulps	ymm2,ymm2,ymm4
  vaddps	ymm1,ymm1,ymm2
  vbroadcastss	ymm3,[const1]
  vsubps	ymm3,ymm3,[s1]
  vmulps	ymm3,ymm3,[const3]
  vmulps	ymm3,ymm3,[s1]
  vmulps	ymm3,ymm3,[s1]
  vmulps	ymm3,ymm3,ymm1
  vaddps	ymm0,ymm0,ymm3

  vbroadcastss	ymm1,[esi+ebx+12*12]
  vmulps	ymm1,ymm1,ymm7
  vbroadcastss	ymm2,[esi+ebx+12*13]
  vmulps	ymm2,ymm2,ymm6
  vaddps	ymm1,ymm1,ymm2
  vbroadcastss	ymm3,[esi+ebx+12*14]
  vmulps	ymm3,ymm3,ymm5
  vaddps	ymm1,ymm1,ymm3
  vbroadcastss	ymm2,[esi+ebx+12*15]
  vmulps	ymm2,ymm2,ymm4
  vaddps	ymm1,ymm1,ymm2

  vmovaps	ymm3,[s1]
  vmulps	ymm2,ymm3,ymm3
  vmulps	ymm2,ymm2,ymm3
  vaddps	ymm0,ymm0,ymm1

  mov		ecx,ebx
  shl		ecx,3
  vshufpd	ymm1,ymm0,ymm0,11101110b

  cvtps2dq	xmm0,xmm0
  cvtps2dq	xmm1,xmm1
  movaps	[px1+ecx],xmm0
  movaps	[px1+ecx+16],xmm1


  add		ebx,8
  cmp		ebx,8*3
  jnz		.ddraw
ret

;------------\\\\\\\\\\\\\\\\\\\\\\\
else

  movss  xmm0,[esi+ebx]
  shufps xmm0,xmm0,0
  mulps  xmm0,xmm7 ;[a1]
  movss  xmm1,[esi+ebx+12]
  shufps xmm1,xmm1,0
  mulps  xmm1,xmm6 ;[b1]
  addps  xmm0,xmm1
  movss  xmm2,[esi+ebx+12*2]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm5  ; [c1]
  addps  xmm0,xmm2
  movss  xmm1,[esi+ebx+12*3]
  shufps xmm1,xmm1,0
  mulps  xmm1,xmm4 ;[d1]
  addps  xmm0,xmm1

  movaps xmm1,[const1]
  subps  xmm1,[s1]
  movaps xmm2,xmm1
  mulps xmm1,xmm2
  mulps xmm1,xmm2
  mulps xmm1,xmm2
  mulps xmm0,xmm1

  movss  xmm1,[esi+ebx+12*4]
  shufps xmm1,xmm1,0
  mulps  xmm1,xmm7 ;[a1]
  movss  xmm2,[esi+ebx+12*5]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm6 ;[b1]
  addps  xmm1,xmm2
  movss  xmm3,[esi+ebx+12*6]
  shufps xmm3,xmm3,0
  mulps  xmm3,xmm5 ;[c1]
  addps  xmm1,xmm3
  movss  xmm2,[esi+ebx+12*7]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm4 ;[d1]
  addps  xmm1,xmm2
  movaps xmm3,[const1]
  subps  xmm3,[s1]
  mulps  xmm3,xmm3
  mulps  xmm3,[s1]
  mulps  xmm3,[const3]
  mulps  xmm3,xmm1
  addps  xmm0,xmm3

  movss  xmm1,[esi+ebx+12*8]
  shufps xmm1,xmm1,0
  mulps  xmm1,xmm7 ;[a1]
  movss  xmm2,[esi+ebx+12*9]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm6 ;[b1]
  addps  xmm1,xmm2
  movss  xmm3,[esi+ebx+12*10]
  shufps xmm3,xmm3,0
  mulps  xmm3,xmm5  ;[c1]
  addps  xmm1,xmm3
  movss  xmm2,[esi+ebx+12*11]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm4  ;[d1]
  addps  xmm1,xmm2
  movaps xmm3,[const1]
  subps  xmm3,[s1]
  mulps  xmm3,[const3]
  mulps  xmm3,[s1]
  mulps  xmm3,[s1]
  mulps  xmm3,xmm1
  addps  xmm0,xmm3


  movss  xmm1,[esi+ebx+12*12]
  shufps xmm1,xmm1,0
  mulps  xmm1,xmm7  ;[a1]
  movss  xmm2,[esi+ebx+12*13]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm6  ;[b1]
  addps  xmm1,xmm2
  movss  xmm3,[esi+ebx+12*14]
  shufps xmm3,xmm3,0
  mulps  xmm3,xmm5  ;[c1]
  addps  xmm1,xmm3
  movss  xmm2,[esi+ebx+12*15]
  shufps xmm2,xmm2,0
  mulps  xmm2,xmm4 ;[d1]
  addps  xmm1,xmm2

  movaps xmm3,[s1]
  mulps  xmm3,xmm3
  mulps  xmm3,[s1]
  mulps  xmm1,xmm3
  addps  xmm0,xmm1

  cvtps2dq xmm0,xmm0
  mov	   ecx,ebx
  shl	   ecx,2
  movdqa   [px1+ecx],xmm0

  add	ebx,4
  cmp	ebx,4*3
  jnz	.ddraw
end if
ret

;[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[



putpixel:
if Ext = AVX
;  vbroadcastss ymm7,[xres_var_f]
;  vmovps       ymm0,[py1]
;  vbroadcastss ymm1,[yres_div2_f]
;  paddd        ymm0,ymm0,ymm1
;  vmaxps       ymm0,ymm0,[const1]
;  vbroadcastss ymm2,[yres_var_sub1]
;  vminps       ymm0,ymm0,ymm2
;  vmulps       ymm0,ymm7

;  vmovps       ymm3,[px1]
;  vbroadcastss ymm4,[xres_div2_f]
;  vaddps       ymm3,ymm3,ymm4
;  maxps        ymm3,[const1]
;  vbroadcastss ymm2,[xres_var_sub1]
;  vminps       ymm3,ymm3,ymm2

;  vaddps       ymm0,ymm3

;  cvtps2dq     ymm0,ymm0

  xor	   ebx,ebx
@@:

  mov	   edx,XRES
  cvtsi2ss xmm7,edx
  shufps   xmm7,xmm7,0
  movdqa   xmm0,[py1+ebx]
  mov	   eax,YRES/2
  movd	   xmm1,eax
  shufps   xmm1,xmm1,0
  paddd    xmm0,xmm1
  cvtdq2ps xmm0,xmm0
  maxps    xmm0,[const1]
  mov	   eax,YRES-1
  cvtsi2ss xmm2,eax
  shufps   xmm2,xmm2,0
  minps    xmm0,xmm2
  mulps    xmm0,xmm7

  movdqa   xmm3,[px1+ebx]
  mov	   eax,XRES/2
  cvtsi2ss xmm4,eax
  shufps   xmm4,xmm4,0
  cvtdq2ps xmm3,xmm3
  addps    xmm3,xmm4
  maxps    xmm3,[const1]
  mov	   eax,XRES-1
  cvtsi2ss xmm2,eax
  shufps   xmm2,xmm2,0
  minps    xmm3,xmm2

  addps    xmm0,xmm3
  cvtps2dq xmm0,xmm0
;    mov      eax,0xffffff
;    movd     xmm3,eax
  pslld    xmm0,2
;    pshufd   xmm3,xmm3,0
;    pand     xmm0,xmm3
  mov	   eax,buffer
  movd	   xmm1,eax
  shufps   xmm1,xmm1,0
  paddd    xmm0,xmm1

  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1

  add	   ebx,16
  cmp	   ebx,32
  jnz	   @b

ret

else

  mov	   edx,XRES
  cvtsi2ss xmm7,edx
  shufps   xmm7,xmm7,0
  movdqa   xmm0,[py1]
  mov	   eax,YRES/2
  movd	   xmm1,eax
  shufps   xmm1,xmm1,0
  paddd    xmm0,xmm1
  cvtdq2ps xmm0,xmm0
  maxps    xmm0,[const1]
  mov	   eax,YRES-1
  cvtsi2ss xmm2,eax
  shufps   xmm2,xmm2,0
  minps    xmm0,xmm2
  mulps    xmm0,xmm7

  movdqa   xmm3,[px1]
  mov	   eax,XRES/2
  cvtsi2ss xmm4,eax
  shufps   xmm4,xmm4,0
  cvtdq2ps xmm3,xmm3
  addps    xmm3,xmm4
  maxps    xmm3,[const1]
  mov	   eax,XRES-1
  cvtsi2ss xmm2,eax
  shufps   xmm2,xmm2,0
  minps    xmm3,xmm2

  addps    xmm0,xmm3
  cvtps2dq xmm0,xmm0
  pslld    xmm0,2
  mov	   eax,buffer
  movd	   xmm1,eax
  shufps   xmm1,xmm1,0
  paddd    xmm0,xmm1

  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1
  psrldq   xmm0,4
  movd	   eax,xmm0
  mov	   dword[eax],-1


ret
end if



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class TCHAR 'Bezier',0
    _title TCHAR 'Bezier surfces  '
    if Ext = SSE2
      .exxt    TCHAR	  'SSE2',0
    else
      .exxt    TCHAR	  'AVX',0
    end if
    _error TCHAR 'Startup failed.',0

    up		dd 0
    s_time	dd 0
    e_time	dd 0
;    num_animations dd 3
    ccounter	   dd 0

    draw_flag db 0
    scale    dd 5.3
    xxadd    dw XRES/2
    yyadd    dw YRES/2
    zzadd    dw 0
    xxadd1   dw XRES*3/4
    screen_width_var dd XRES
    xres_var dw XRES-1
    yres_var dw YRES-1
 ;   yyadd1   dw YRES*3/4
 ;   zzadd    dw 300
    one_deg  dd   0.024543692
    msg  MSG
    rect RECT


maxcountervar dw MAX_COUNTER	  ; should be divisible by 4 or by 8 in AVX cause
maxcountervarExt dw ?
step dd 0.05
i3   dw  3
f4   dd  4.0
align 32
const1:
 dd 1.0, 1.0, 1.0, 1.0
 dd 1.0, 1.0, 1.0, 1.0
align 32
const3:
 dd 3.0, 3.0, 3.0, 3.0
 dd 3.0, 3.0, 3.0, 3.0
const4:
 dd 4.0, 4.0, 4.0, 4.0
align 32
const8:
 dd 8.0, 8.0, 8.0, 8.0, 8.0, 8.0, 8.0, 8.0
const0123:
 dd 0.0, 1.0, 2.0, 3.0
 dd 4.0, 5.0, 6.0, 7.0
minxy:
     dd  1.0, 1.0, 1.0, 1.0
;p1x  dd  50.0
;p1y  dd  50.0
;p1z  dd  0.0

;p2x  dd  25.0
;p2y  dd  150.0
;p2z  dd  0.0

;p3x  dd  150.0
;p3y  dd  150.0
;p3z  dd  0.0

;p4x  dd  125.0
;p4y  dd  50.0
;p4z  dd  0.0
 ;   P.x= (1-t)^3*P_1.x + 3*(1-t)^2*t*P_2.x + 3*(1-t)*t^2*P_3.x + t^3*P_4.x
 ;   P.y= (1-t)^3*P_1.y + 3*(1-t)^2*t*P_2.y + 3*(1-t)*t^2*P_3.y + t^3*P_4.y
 ;   P.z= (1-t)^3*P_1.z + 3*(1-t)^2*t*P_2.z + 3*(1-t)*t^2*P_3.z + t^3*P_4.z
 ;   px = a*p1x + b*p2x + c*p3x + d*p4x
 ;   a  = (1-t)^3
 ;   b  = 3*(1-t)^2*t
 ;   c  = 3*(1-t)*t^2
 ;   d  = t^3
object:

include 'utah.inc'

    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_class

    s dd ?
    t dd ?
object_rotated:
    rb 65536
    ipx        dw ?
    ipy        dw ?
    counter    dw ?
    surface_no dd ?
align 32

 step8:
 step4:
    rd 4
    rd 4
    rd 4
    rd 4
align 16
    maxx:
      rd 4
    maxy:
      rd 4
align 32
 px1:	  dd ?
    px2   dd ?
    px3   dd ?
    px4   dd ?
 px5:
    rd	  4
 py1:	  dd ?
    py2   dd ?
    py3   dd ?
    py4   dd ?
 py5:
    rd	  4
 pz1:	  dd ?
    pz2   dd ?
    pz3   dd ?
    pz4   dd ?
 pz5:
    rd	  4
 t1:	 dd ?
    t2	 dd ?
    t3	 dd ?
    t4	 dd ?
    t5	 dd ?
    t6	 dd ?
    t7	 dd ?
    t8	 dd ?
s1:
       dd ?
    s2 dd ?
    s3 dd ?
    s4 dd ?
    s5 dd ?
    s6 dd ?
    s7 dd ?
    s8 dd ?


 a1:	 dd ?
    a2	 dd ?
    a3	 dd ?
    a4	 dd ?
    rd	 4
 b1:	 dd ?
    b2	 dd ?
    b3	 dd ?
    b4	 dd ?
    rd	 4
 c1:	 dd ?
    c2	 dd ?
    c3	 dd ?
    c4	 dd ?
    rd	 4
 d1:	 dd ?
    d2	 dd ?
    d3	 dd ?
    d4	 dd ?
    rd	 4

    rest dd ?
    px	 dd ?
    py	 dd ?
    pz	 dd ?
 ;   t    dd ?
    a	 dd ?
    b	 dd ?
    c	 dd ?
    d	 dd ?
    cos_beta dd ?
    sin_beta dd ?
    hwnd     dd ?
    hdc      dd ?
    bmi      BITMAPINFOHEADER
    buffer   rd XRES*YRES


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM'

    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'

    import winmm,timeGetTime,'timeGetTime'
